#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPX(op, t, x) operator op(CRP(t, x))
#define OPL(t, x) bool OPX(<, t, x) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef int64_t ll, i64;
typedef uint64_t ull, u64;
template <typename... Types>
using comtype = typename common_type<Types...>::type;
template <typename T>
using enable_if_arithmetic = typename enable_if<is_arithmetic<T>::value>::type;
template <typename T>
using enable_if_integral = typename enable_if<is_integral<T>::value>::type;
inline char getchar(int)
{
    static char buf[64 << 20], *S = buf, *T = buf;
    if (S == T) T = fread(S = buf, 1, 64 << 20, stdin) + buf;
    return S == T ? EOF : *S++;
}
template <typename T, typename = enable_if_integral<T>>
inline bool read(T &x)
{
    int ch = x = 0, f = 1;
    while (!isdigit(ch = getchar()))
        if (ch == EOF)
            return false;
        else if (ch == '-')
            f = 0;
    for (; isdigit(ch); ch = getchar()) x = x * 10 + ch - '0';
    return x = f ? x : -x, true;
}
template <typename T, typename... Args, typename = enable_if_integral<T>>
inline bool read(T &x, Args &... args) { return read(x) && read(args...); }
template <typename T1, typename T2, typename TResult = comtype<T1, T2>>
inline TResult mmin(CRP(T1, v1), CRP(T2, v2)) { return min<TResult>(v1, v2); }
template <typename T, typename... Args, typename TResult = comtype<T, Args...>>
inline TResult mmin(CRP(T, v), const Args &... args) { return min<TResult>(v, mmin(args...)); }
template <typename T1, typename T2, typename TResult = comtype<T1, T2>>
inline TResult mmax(CRP(T1, v1), CRP(T2, v2)) { return max<TResult>(v1, v2); }
template <typename T, typename... Args, typename TResult = comtype<T, Args...>>
inline TResult mmax(CRP(T, v), const Args &... args) { return max<TResult>(v, mmax(args...)); }
inline ll gcd(ll a, ll b)
{
    for (; b; swap(a, b)) a %= b;
    return a;
}
inline ll fpow(ll a, ll b, ll m)
{
    ll r = 1;
    for (; b; b >>= 1, a = a * a % m)
        if (b & 1) r = r * a % m;
    return r;
}
constexpr double eps = 1e-8;
inline int sgn(double x) { return x > eps ? 1 : x < -eps ? -1 : 0; }
const int N = 20050;
template <size_t N, size_t M = N>
struct Graph
{
    // Basic
    struct Edge
    {
        int nxt, to, len;
    };
    int adj[N], ecnt;
    Edge E[M];
    void addEdge(int f, int t, int l)
    {
        E[ecnt] = {adj[f], t, l};
        adj[f] = ecnt++;
    }
    void reset() { NE1(adj), ecnt = 0; }
    // Dijkstra
    ll dis[N];
    void Dijstra(int S)
    {
        struct node
        {
            int x;
            ll v;
            OPL(node, rhs) { return v > rhs.v; }
        };
        priority_queue<node> H;
        INF(dis);
        H.push({S, dis[S] = 0});
        for (node cur; !H.empty(); H.pop())
            for (int e = adj[(cur = H.top()).u]; ~e; e = E[e].nxt)
                if (dis[E[e].to] > dis[cur.u] + E[e].len)
                    H.push({E[e].to, dis[E[e].to] = dis[cur.u] + E[e].len});
    }
    // ISAP
    void addEdge_ISAP(int f, int t, int l)
    {
        addEdge(f, t, l);
        addEdge(t, f, 0);
    }
};
Graph<N> G, G2;
struct
{
    int f, t, l;
} Es[N];
int main()
{
    int T, n, m;
    read(T);
    while (T--)
    {
        G.reset();
        read(n, m);
        for (int i = 0; i < m; i++)
            read(Es[i].f, Es[i].t, Es[i].l), G.addEdge(Es[i].f, Es[i].t, Es[i].l);
        G.reset();
        for (int i = 0; i < m; i++)
            if (G.dis[Es[i].f] + Es[i].l == G.dis[Es[i].t])
                G.addEdge_ISAP(Es[i].f, Es[i].t, Es[i].l);
    }
    return 0;
}